<template>
  <ck-base-item-bis
    :tabindex="tabindex"
    :item-id="item.id"
    :label="item.label"
    :checked="item.ticked"
    :focus-on-mount="focusOnMount"
    :apparitionOrder="item.ordre"
    :collection-id="collectionId"
    @setup-create="$emit('setup-create')"
    @setup-edit="setupEdit"
    @item-update="update"
  >
    <template #checkbox="{ color }">
      <v-checkbox
        :model-value="item.ticked"
        :color="color"
        @click.stop="$emit('clicked')"
        hide-details></v-checkbox>
    </template>
    <template #edit>
      <simple-item-form
        v-model="editingItem"
        @setup-create="$emit('setup-create')"
      ></simple-item-form>
    </template>
  </ck-base-item-bis>
</template>

<script setup>
import { useDisplay } from 'vuetify'

const { mobile } = useDisplay()
</script>

<script>
import CkBaseItemBis from '@/components/item/ck-base-item.vue'
import SimpleItemForm from '@/components/item/simple/simple-item-form.vue'
import { toRaw } from 'vue'
import { useCollectionsStore } from '@/stores/itemCollections.js'
export default {
  components: { SimpleItemForm, CkBaseItemBis },
  props: {
    item: {
      type: Object,
      required: true
    },
    tabindex: {
      type: Number,
      required: true
    },
    focusOnMount:  {
      type: Boolean,
      default: false
    },
    collectionId:  {
      type: String,
      required: true
    },
  },
  data() {
    return {
      editingItem: {}
    }
  },
  methods: {
    setupEdit() {
      this.editingItem = structuredClone(toRaw(this.item))
    },
    update() {
      useCollectionsStore().updateSimpleItem(this.collectionId, this.item.id, this.editingItem)
    }
  }
}
</script>
